=== debian/changelog ===
olsrd (0.6.3-5) unstable; urgency=low

  * fixed build system so all hardening flags are applied
  * fixed some lintian warnings
  * make tas plugin build against Debian's lua rather than the lua sources
    that are included in the olsrd orig tarball

 -- Hans-Christoph Steiner <hans@eds.org>  Fri, 05 Oct 2012 17:38:02 -0400

olsrd (0.6.3-4) unstable; urgency=low

  * debian/rules: Drop OS=linux from the make call, fixing FTBFS on !linux,
    thanks to Evgeni Golov (Closes: #679761)

 -- Roland Stigge <stigge@antcom.de>  Fri, 06 Jul 2012 18:58:27 +0200

olsrd (0.6.3-3) unstable; urgency=low

  * update broken jsoninfo plugin with patches from upstream git
  * updated default config based on settings from funkfeuer and
    commotionwireless.net

 -- Hans-Christoph Steiner <hans@eds.org>  Sat, 30 Jun 2012 09:57:55 -0400

olsrd (0.6.3-2) unstable; urgency=low

  * Re-upload to unstable

 -- Roland Stigge <stigge@antcom.de>  Sun, 24 Jun 2012 18:00:24 +0200

olsrd (0.6.3-1) experimental; urgency=low

  * New upstream release
  * debian/control: Standards-Version: 3.9.3

 -- Roland Stigge <stigge@antcom.de>  Fri, 08 Jun 2012 12:30:36 +0200
